#!/bin/sh
#
# Requires wmctrl
#
# switch for some fvwm2 themes using wmctrl
# useful for cde
#

rmode="$1"

if test "$rmode" = init
then
    exit 0
fi

#------------------------------------------------------------------------------
# settings
#------------------------------------------------------------------------------
if test -x /usr/local/bin/wmctrl
then
    WMCTRL=/usr/local/bin/wmctrl
else
    if test -x /opt/jmc/bin/wmctrl
    then
	WMCTRL=/opt/jmc/bin/wmctrl
    else
	WMCTRL=wmctrl
    fi
fi
export WMCTRL

max_desk=`$WMCTRL -d | wc -l | sed 's/ //g'`
max_desk=`expr $max_desk - 1`

now=`wmctrl -d | grep '^[0-9]  \*' | cut -c '1-2' | sed 's/ //g'`

#echo "DEBUG `date`: rmode: $rmode   now: $now   max: $max_desk" >> $HOME/x

#------------------------------------------------------------------------------
# process
#------------------------------------------------------------------------------
case "$rmode" in
    "0"|"1"|"2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"|"10"|"11"|"12"|"13"|"14"|"15"|"16"|"17"|"18"|"19")
	if test "$rmode" -le "$max_desk"
	then
	    $WMCTRL -s "$rmode"
	fi
	;;
    "next")
	nd=`expr $now + 1`
	if test "$nd" -gt "$max_desk"
	then
	    nd=0
	fi
	$WMCTRL -s "$nd"
	;;
    "prev")
	if test "$now" -eq "0"
	then
	    nd="$max_desk"
	else
	    nd=`expr $now - 1`
	fi
	$WMCTRL -s "$nd"
	;;
    "up4"|"down4")
	# move down when 4 desktops
        #    0 1
        #    2 3
	case "$now" in
	    "0")
		nd=2
		;;
	    "1")
		nd=3
		;;
	    "2")
		nd=0
		;;
	    "3")
		nd=1
		;;
	esac
	$WMCTRL -s "$nd"
	;;
    "left4"|"right4")
	# move down when 4 desktops
        #    0 1
        #    2 3
	case "$now" in
	    "0")
		nd=1
		;;
	    "1")
		nd=0
		;;
	    "2")
		nd=3
		;;
	    "3")
		nd=2
		;;
	esac
	$WMCTRL -s "$nd"
	;;
esac

#------------------------------------------------------------------------------
# done
#------------------------------------------------------------------------------
exit 0
