#!/bin/sh
#
# obtains a screen print, seems xwd work best
#         needs ImageMagick -- http://www.imagemagick.org/
#

#------------------------------------------------------------------------------
# doxwd() -- use xwd and if possible convert image
#------------------------------------------------------------------------------
doxwd()
{
    fn=$HOME/screen`date "+%Y%m%d-%H%M%S"`
    ofile=$fn.xwd
    jfile=$fn.png
    type xwd > /dev/null 2>&1
    if test "$?" -eq "0"
    then
	type convert > /dev/null 2>&1
	if test "$?" -eq "0"
	then
	    xwd | convert xwd:- png:"$jfile"
	else
	    xwd -frame -out $ofile
	fi
    else
	xmessage -timeout 5 "E01: xwd missing, cannot print screen" &
    fi

} # END: doxwd()

###############################################################################
# main()
###############################################################################
rmode="$1"

case "$rmode" in
    "ksnapshot")
	type ksnapshot > /dev/null 2>&1
	if test "$?" -eq "0"
	then
	    ksnapshot &
	else
	    doxwd
	fi
	;;
    *)
	doxwd
	;;
esac

exit 0

